diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/Taxon.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/Taxon.java
index 0fbd2aaf34..e4ad8d7c43 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/Taxon.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/Taxon.java
@@ -41,6 +41,7 @@ import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
 import org.hibernate.envers.Audited;
 import org.hibernate.search.annotations.ClassBridge;
+import org.hibernate.search.annotations.ClassBridges;
 import org.hibernate.search.annotations.ContainedIn;
 import org.hibernate.search.annotations.Indexed;
 import org.hibernate.search.annotations.IndexedEmbedded;
@@ -48,6 +49,7 @@ import org.springframework.beans.factory.annotation.Configurable;
 import org.springframework.util.ReflectionUtils;
 
 import eu.etaxonomy.cdm.hibernate.search.GroupByTaxonClassBridge;
+import eu.etaxonomy.cdm.hibernate.search.TaxonRelationshipClassBridge;
 import eu.etaxonomy.cdm.model.common.IRelated;
 import eu.etaxonomy.cdm.model.common.RelationshipBase;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
@@ -84,7 +86,10 @@ import eu.etaxonomy.cdm.strategy.cache.taxon.TaxonBaseDefaultCacheStrategy;
 @Indexed(index = "eu.etaxonomy.cdm.model.taxon.TaxonBase")
 @Audited
 @Configurable
-@ClassBridge(impl=GroupByTaxonClassBridge.class)
+@ClassBridges({
+    @ClassBridge(impl = GroupByTaxonClassBridge.class),
+    @ClassBridge(impl = TaxonRelationshipClassBridge.class)
+})
 public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> implements IRelated<RelationshipBase>, Cloneable{
     private static final long serialVersionUID = -584946869762749006L;
     private static final Logger logger = Logger.getLogger(Taxon.class);
@@ -144,7 +149,6 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
     private Taxon taxonomicParentCache;
 
 
-
     @XmlElementWrapper(name = "taxonNodes")
     @XmlElement(name = "taxonNode")
     @XmlIDREF
@@ -158,33 +162,25 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
     @XmlElement(name = "TaxonomicChildrenCount")
     @Deprecated //will be removed in future versions. Use Classification/TaxonNode instead
     private int taxonomicChildrenCount;
-
-// ************* CONSTRUCTORS *************/
-
-    //TODO should be private, but still produces Spring init errors
-    @Deprecated
-    public Taxon(){
-        this.cacheStrategy = new TaxonBaseDefaultCacheStrategy<Taxon>();
-    }
-
+    
+// ************************* FACTORY METHODS ********************************/
+    
     /**
-     * Class constructor: creates a new (accepted/correct) taxon instance with
+     * Creates a new (accepted/correct) taxon instance with
      * the {@link eu.etaxonomy.cdm.model.name.TaxonNameBase taxon name} used and the {@link eu.etaxonomy.cdm.model.reference.Reference reference}
      * using it.
      *
      * @param  taxonNameBase	the taxon name used
      * @param  sec				the reference using the taxon name
-     * @see    					TaxonBase#TaxonBase(TaxonNameBase, Reference)
+     * @see    					#Taxon(TaxonNameBase, Reference)
      */
-    public Taxon(TaxonNameBase taxonNameBase, Reference sec){
-        super(taxonNameBase, sec);
-        this.cacheStrategy = new TaxonBaseDefaultCacheStrategy<Taxon>();
+    public static Taxon NewInstance(TaxonNameBase taxonNameBase, Reference sec){
+        Taxon result = new Taxon(taxonNameBase, sec);
+        return result;
     }
 
-//********* METHODS **************************************/
-
     /**
-     * Creates a new (accepted/correct) taxon instance with
+     * Creates a new taxon instance with an unknown status (accepted/synonym) and with
      * the {@link eu.etaxonomy.cdm.model.name.TaxonNameBase taxon name} used and the {@link eu.etaxonomy.cdm.model.reference.Reference reference}
      * using it.
      *
@@ -192,26 +188,37 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
      * @param  sec				the reference using the taxon name
      * @see    					#Taxon(TaxonNameBase, Reference)
      */
-    public static Taxon NewInstance(TaxonNameBase taxonNameBase, Reference sec){
+    public static Taxon NewUnknownStatusInstance(TaxonNameBase taxonNameBase, Reference sec){
         Taxon result = new Taxon(taxonNameBase, sec);
+        result.setTaxonStatusUnknown(true);
         return result;
     }
+// ************* CONSTRUCTORS *************/
+
+    //TODO should be private, but still produces Spring init errors
+    @Deprecated
+    public Taxon(){
+        this.cacheStrategy = new TaxonBaseDefaultCacheStrategy<Taxon>();
+    }
 
     /**
-     * Creates a new taxon instance with an unknown status (accepted/synonym) and with
+     * Class constructor: creates a new (accepted/correct) taxon instance with
      * the {@link eu.etaxonomy.cdm.model.name.TaxonNameBase taxon name} used and the {@link eu.etaxonomy.cdm.model.reference.Reference reference}
      * using it.
      *
      * @param  taxonNameBase	the taxon name used
      * @param  sec				the reference using the taxon name
-     * @see    					#Taxon(TaxonNameBase, Reference)
+     * @see    					TaxonBase#TaxonBase(TaxonNameBase, Reference)
      */
-    public static Taxon NewUnknownStatusInstance(TaxonNameBase taxonNameBase, Reference sec){
-        Taxon result = new Taxon(taxonNameBase, sec);
-        result.setTaxonStatusUnknown(true);
-        return result;
+    public Taxon(TaxonNameBase taxonNameBase, Reference sec){
+        super(taxonNameBase, sec);
+        this.cacheStrategy = new TaxonBaseDefaultCacheStrategy<Taxon>();
     }
 
+//********* METHODS **************************************/
+
+
+
     /**
      * Returns the set of {@link eu.etaxonomy.cdm.model.description.TaxonDescription taxon descriptions}
      * concerning <i>this</i> taxon.
@@ -463,10 +470,12 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
         Set<TaxonRelationship> relations = new HashSet<TaxonRelationship>();
 
         for(TaxonRelationship relationship : getTaxonRelations()){
-            if(relationship.getFromTaxon().equals(possiblyRelatedTaxon))
+            if(relationship.getFromTaxon().equals(possiblyRelatedTaxon)) {
                 relations.add(relationship);
-            if(relationship.getToTaxon().equals(possiblyRelatedTaxon))
+            }
+            if(relationship.getToTaxon().equals(possiblyRelatedTaxon)) {
                 relations.add(relationship);
+            }
         }
 
         return relations.size() > 0 ? relations : null;
@@ -588,6 +597,7 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
     /* (non-Javadoc)
      * @see eu.etaxonomy.cdm.model.common.IRelated#addRelationship(eu.etaxonomy.cdm.model.common.RelationshipBase)
      */
+    @Override
     @Deprecated //for inner use by RelationshipBase only
     public void addRelationship(RelationshipBase rel){
         if (rel instanceof TaxonRelationship){
@@ -1525,17 +1535,18 @@ public class Taxon extends TaxonBase<IIdentifiableEntityCacheStrategy<Taxon>> im
         return unplaced;
     }
 
+    @Override
     @Transient
     public boolean isOrphaned() {
-    	
-    	if(taxonNodes == null || taxonNodes.isEmpty()) {
-    		if(getRelationsFromThisTaxon().isEmpty() && getRelationsToThisTaxon().isEmpty()) {
-				return true;
-	    	}
-    	}
-    	return false;
+
+        if(taxonNodes == null || taxonNodes.isEmpty()) {
+            if(getRelationsFromThisTaxon().isEmpty() && getRelationsToThisTaxon().isEmpty()) {
+                return true;
+            }
+        }
+        return false;
     }
-    
+
     public void setUnplaced(boolean unplaced) {
         this.unplaced = unplaced;
     }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonBase.java
index c63630d34e..1c7a9d2382 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonBase.java
@@ -61,7 +61,6 @@ import eu.etaxonomy.cdm.validation.annotation.TaxonNameCannotBeAcceptedAndSynony
  * </ul>
  *
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:56
  */
 @XmlAccessorType(XmlAccessType.FIELD)
@@ -69,6 +68,7 @@ import eu.etaxonomy.cdm.validation.annotation.TaxonNameCannotBeAcceptedAndSynony
     "name",
     "sec",
     "doubtful",
+    "publish",
     "appendedPhrase",
     "useNameCache"
 })
@@ -78,14 +78,14 @@ import eu.etaxonomy.cdm.validation.annotation.TaxonNameCannotBeAcceptedAndSynony
 @Table(appliesTo="TaxonBase", indexes = { @Index(name = "taxonBaseTitleCacheIndex", columnNames = { "titleCache" }) })
 @TaxonNameCannotBeAcceptedAndSynonym(groups = Level3.class)
 @ClassBridges({
-	@ClassBridge(name="classInfo",
-			index = org.hibernate.search.annotations.Index.YES, 
-			store = Store.YES,
-			impl = ClassInfoBridge.class),
-	@ClassBridge(name="accTaxon",
-			index = org.hibernate.search.annotations.Index.YES, 
-			store = Store.YES,
-			impl = AcceptedTaxonBridge.class)
+    @ClassBridge(name="classInfo",
+            index = org.hibernate.search.annotations.Index.YES,
+            store = Store.YES,
+            impl = ClassInfoBridge.class),
+    @ClassBridge(name="accTaxon", // TODO rename to acceptedTaxon, since we are usually not using abbreviations for field names
+            index = org.hibernate.search.annotations.Index.YES,
+            store = Store.YES,
+            impl = AcceptedTaxonBridge.class)
 })
 public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> extends IdentifiableEntity<S> implements Cloneable {
     private static final long serialVersionUID = -3589185949928938529L;
@@ -108,6 +108,9 @@ public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> exte
     //The assignment to the Taxon or to the Synonym class is not definitive
     @XmlAttribute(name = "isDoubtful")
     private boolean doubtful;
+    
+    @XmlAttribute(name = "publish")
+    private boolean publish = true;
 
     @XmlElement(name = "Name", required = true)
     @XmlIDREF
@@ -230,8 +233,8 @@ public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> exte
 
     /**
      * Returns the boolean value indicating whether the assignment of <i>this</i>
-     * (abstract) taxon to the {@link Taxon Taxon} or to the {@link Synonym Synonym} class is definitive
-     * (false) or not (true). If this flag is set the use of <i>this</i> (abstract)
+     * (abstract) taxon to the {@link Taxon Taxon} or to the {@link Synonym Synonym} class 
+     * is definitive (false) or not (true). If this flag is set the use of <i>this</i> (abstract)
      * taxon as an "accepted/correct" name or as a (junior) "synonym" might
      * still change in the course of taxonomical working process.
      */
@@ -244,6 +247,22 @@ public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> exte
     public void setDoubtful(boolean doubtful){
         this.doubtful = doubtful;
     }
+    
+
+	/**
+	 * Returns the boolean value indicating if this taxon should be withheld (<code>publish=false</code>) or not 
+	 * (<code>publish=true</code>) during any publication process to the general public.
+	 * This publish flag implementation is preliminary and may be replaced by a more general 
+	 * implementation of READ rights in future.<BR>
+	 * The default value is <code>true</code>.
+	 */
+	public boolean isPublish() {
+		return publish;
+	}
+
+	public void setPublish(boolean publish) {
+		this.publish = publish;
+	}
 
     /**
      * Returns the {@link eu.etaxonomy.cdm.model.reference.Reference reference} of <i>this</i> (abstract) taxon.
@@ -294,7 +313,7 @@ public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> exte
     public void setUseNameCache(boolean useNameCache) {
         this.useNameCache = useNameCache;
     }
-    
+
     @Transient
     public abstract boolean isOrphaned();
 //*********************** CLONE ********************************************************/
@@ -323,4 +342,5 @@ public abstract class TaxonBase<S extends IIdentifiableEntityCacheStrategy> exte
 
     }
 
+
 }
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonNode.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonNode.java
index 1451932ed7..07cd6ec8c4 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonNode.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/taxon/TaxonNode.java
@@ -12,13 +12,17 @@ package eu.etaxonomy.cdm.model.taxon;
 
 import java.util.ArrayList;
 import java.util.HashSet;
+import java.util.List;
 import java.util.Set;
 
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
 import javax.persistence.ManyToOne;
 import javax.persistence.OneToMany;
+import javax.persistence.OrderBy;
+import javax.persistence.OrderColumn;
 import javax.persistence.Transient;
+import javax.validation.constraints.Size;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
@@ -38,18 +42,20 @@ import org.hibernate.search.annotations.IndexedEmbedded;
 
 import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
+import eu.etaxonomy.cdm.model.common.ITreeNode;
 import eu.etaxonomy.cdm.model.reference.Reference;
 
 /**
  * @author a.mueller
  * @created 31.03.2009
- * @version 1.0
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "TaxonNode", propOrder = {
-    "taxon",
+	"classification",
+	"taxon",
     "parent",
-    "classification",
+    "treeIndex",
+    "sortIndex",
     "childNodes",
     "referenceForParentChildRelation",
     "microReferenceForParentChildRelation",
@@ -60,7 +66,7 @@ import eu.etaxonomy.cdm.model.reference.Reference;
 @Entity
 @Indexed(index = "eu.etaxonomy.cdm.model.taxon.TaxonNode")
 @Audited
-public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable{
+public class TaxonNode extends AnnotatableEntity implements ITaxonTreeNode, ITreeNode<TaxonNode>, Cloneable{
     private static final long serialVersionUID = -4743289894926587693L;
     private static final Logger logger = Logger.getLogger(TaxonNode.class);
 
@@ -79,7 +85,12 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
     @ManyToOne(fetch = FetchType.LAZY)
     @Cascade({CascadeType.SAVE_UPDATE, CascadeType.MERGE})
     private TaxonNode parent;
-
+    
+   
+    @XmlElement(name = "treeIndex")
+    @Size(max=255)
+    private String treeIndex;	
+    
 
     @XmlElement(name = "classification")
     @XmlIDREF
@@ -94,9 +105,15 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
     @XmlElement(name = "childNode")
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
+    //see https://dev.e-taxonomy.eu/trac/ticket/3722
+    @OrderColumn(name="sortIndex")
+    @OrderBy("sortIndex")
     @OneToMany(mappedBy="parent", fetch=FetchType.LAZY)
     @Cascade({CascadeType.SAVE_UPDATE, CascadeType.MERGE})
-    private Set<TaxonNode> childNodes = new HashSet<TaxonNode>();
+    private List<TaxonNode> childNodes = new ArrayList<TaxonNode>();
+     
+    //see https://dev.e-taxonomy.eu/trac/ticket/3722
+    private Integer sortIndex = -1;
 
     @XmlElement(name = "reference")
     @XmlIDREF
@@ -152,15 +169,20 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
 
 //************************ METHODS **************************/
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.taxon.ITreeNode#addChildTaxon(eu.etaxonomy.cdm.model.taxon.Taxon, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String, eu.etaxonomy.cdm.model.taxon.Synonym)
-     */
-    public TaxonNode addChildTaxon(Taxon taxon, Reference citation, String microCitation, Synonym synonymToBeUsed) {
+    @Override
+    public TaxonNode addChildTaxon(Taxon taxon, Reference citation, String microCitation) {
+    	return addChildTaxon(taxon, this.childNodes.size(), citation, microCitation);
+    
+    }
+
+
+    @Override
+    public TaxonNode addChildTaxon(Taxon taxon, int index, Reference citation, String microCitation) {
         if (this.getClassification().isTaxonInTree(taxon)){
-             throw new IllegalArgumentException(String.format("Taxon may not be in a taxonomic view twice: %s", taxon.getTitleCache()));
-        }
+            throw new IllegalArgumentException(String.format("Taxon may not be in a taxonomic view twice: %s", taxon.getTitleCache()));
+       }
 
-        return addChildNode(new TaxonNode(taxon), citation, microCitation, synonymToBeUsed);
+       return addChildNode(new TaxonNode(taxon), index, citation, microCitation);	
     }
 
     /**
@@ -169,21 +191,62 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      * @param childNode the taxon node to be moved to the new parent
      * @return the child node in the state of having a new parent
      */
-    public TaxonNode addChildNode(TaxonNode childNode, Reference reference, String microReference, Synonym synonymToBeUsed){
-
-        // check if this node is a descendant of the childNode
-        if(childNode.getParentTreeNode() != this && childNode.isAncestor(this)){
-            throw new IllegalAncestryException("New parent node is a descendant of the node to be moved.");
-        }
-
-        childNode.setParentTreeNode(this);
-
-        childNode.setReference(reference);
-        childNode.setMicroReference(microReference);
-        childNode.setSynonymToBeUsed(synonymToBeUsed);
+    @Override
+    public TaxonNode addChildNode(TaxonNode childNode, Reference reference, String microReference){
 
+        addChildNode(childNode, childNodes.size(), reference, microReference);
         return childNode;
     }
+    
+	/**
+	 * Inserts the given taxon node in the list of children of <i>this</i> taxon node
+	 * at the given (index + 1) position. If the given index is out of bounds
+	 * an exception will arise.<BR>
+	 * Due to bidirectionality this method must also assign <i>this</i> taxon node
+	 * as the parent of the given child.
+	 * 
+	 * @param	child	the taxon node to be added 
+	 * @param	index	the integer indicating the position at which the child
+	 * 					should be added 
+	 * @see				#getChildNodes()
+	 * @see				#addChildNode(TaxonNode, Reference, String, Synonym) 
+	 * @see				#deleteChildNode(TaxonNode)
+	 * @see				#deleteChildNode(int) 
+	 */
+    @Override
+    public TaxonNode addChildNode(TaxonNode child, int index, Reference reference, String microReference){
+		if (index < 0 || index > childNodes.size() + 1){
+			throw new IndexOutOfBoundsException("Wrong index: " + index);
+		}
+	       // check if this node is a descendant of the childNode
+        if(child.getParentTreeNode() != this && child.isAncestor(this)){
+            throw new IllegalAncestryException("New parent node is a descendant of the node to be moved.");
+        }
+   
+		
+//		if (child.getParent() != null){
+//			child.getParent().deleteChildNode(child);
+//		}
+
+		child.setParentTreeNode(this, index);
+
+		
+//		child.setParent(this);
+//		child.setClassification(this.getClassification());
+//		childNodes.add(index, child);
+		//TODO workaround (see sortIndex doc)
+		for(int i = 0; i < childNodes.size(); i++){
+			childNodes.get(i).sortIndex = i;
+		}
+		child.sortIndex = index;
+		
+        child.setReference(reference);
+        child.setMicroReference(microReference);
+//        childNode.setSynonymToBeUsed(synonymToBeUsed);
+
+        return child;
+
+	}
 
     /**
      * Sets this nodes classification. Updates classification of child nodes recursively
@@ -201,11 +264,8 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
             }
         }
     }
-
-
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.cdm.model.taxon.ITreeNode#removeChildNode(eu.etaxonomy.cdm.model.taxon.TaxonNode)
-     */
+    
+	@Override
     public boolean deleteChildNode(TaxonNode node) {
         boolean result = removeChildNode(node);
 
@@ -238,24 +298,72 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      */
     protected boolean removeChildNode(TaxonNode childNode){
         boolean result = false;
-
-        if(childNode == null){
-            throw new IllegalArgumentException("TaxonNode may not be null");
-        }
-        if(HibernateProxyHelper.deproxy(childNode.getParent(), TaxonNode.class) != this){
-            throw new IllegalArgumentException("TaxonNode must be a child of this node");
-        }
-
-        result = childNodes.remove(childNode);
-        this.countChildren--;
-        if (this.countChildren < 0){
-            throw new IllegalStateException("children count must not be negative ");
-        }
-        childNode.setParent(null);
-        childNode.setClassification(null);
+       
+	    if(childNode == null){
+	    	throw new IllegalArgumentException("TaxonNode may not be null");
+	    }
+        int index = childNodes.indexOf(childNode);
+		if (index >= 0){
+			removeChild(index);
+		}
+        
+
+//		OLD
+//        if(HibernateProxyHelper.deproxy(childNode.getParent(), TaxonNode.class) != this){
+//            throw new IllegalArgumentException("TaxonNode must be a child of this node");
+//        }
+//
+//        result = childNodes.remove(childNode);
+//        this.countChildren--;
+//        if (this.countChildren < 0){
+//            throw new IllegalStateException("Children count must not be negative ");
+//        }
+//        childNode.setParent(null);
+//        childNode.setClassification(null);
 
         return result;
     }
+    
+	/** 
+	 * Removes the child node placed at the given (index + 1) position
+	 * from the list of {@link #getChildNodes() children} of <i>this</i> taxon node.
+	 * Sets the parent and the classification of the child
+     * node to null.
+	 * If the given index is out of bounds no child will be removed. 
+	 *
+	 * @param  index	the integer indicating the position of the taxon node to
+	 * 					be removed
+	 * @see     		#getChildNodes()
+	 * @see				#addChildNode(TaxonNode, Reference, String) 
+	 * @see				#addChildNode(TaxonNode, int, Reference, String)
+	 * @see				#deleteChildNode(TaxonNode)
+	 */
+	public void removeChild(int index){
+		
+		TaxonNode child = childNodes.get(index);
+		child = HibernateProxyHelper.deproxy(child, TaxonNode.class); //strange that this is required, but otherwise child.getParent() returns null for some lazy-loaded items.
+		
+		if (child != null){
+			
+			TaxonNode parent = HibernateProxyHelper.deproxy(child.getParent(), TaxonNode.class);
+			TaxonNode thisNode = HibernateProxyHelper.deproxy(this, TaxonNode.class);
+	        if(parent != null && parent != thisNode){
+	            throw new IllegalArgumentException("Child TaxonNode (id:" + child.getId() +") must be a child of this (id:" + thisNode.getId() + " node. Sortindex is: " + index + ", parent-id:" + parent.getId());
+	        }else if (parent == null){
+	            throw new IllegalStateException("Parent of child is null in TaxonNode.removeChild(int). This should not happen.");
+	        }
+			childNodes.remove(index);
+			this.countChildren = childNodes.size();
+			child.setParent(null);
+			//TODO workaround (see sortIndex doc)
+			for(int i = 0; i < countChildren; i++){
+				TaxonNode childAt = childNodes.get(i);
+				childAt.sortIndex = i;
+			}
+			child.sortIndex = null;
+			child.setClassification(null);
+		}
+	}
 
 
     /**
@@ -273,6 +381,24 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
 
 //*********** GETTER / SETTER ***********************************/
 
+	@Override
+    public String treeIndex() {
+		return treeIndex;
+	}
+	
+	@Override
+	@Deprecated //for CDM lib internal use only, may be removed in future versions
+	public void setTreeIndex(String treeIndex) {
+		this.treeIndex = treeIndex;
+	}
+    
+
+	@Override
+	@Deprecated //for CDM lib internal use only, may be removed in future versions
+	public int treeId() {
+		return this.classification.getId();
+	}
+    
     public Taxon getTaxon() {
         return taxon;
     }
@@ -283,9 +409,10 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         }
     }
     @Transient
-    public ITreeNode getParentTreeNode() {
-        if(isTopmostNode())
+    public ITaxonTreeNode getParentTreeNode() {
+        if(isTopmostNode()){
             return getClassification();
+        }
         return parent;
     }
 
@@ -303,7 +430,7 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      *
      * @see setParentTreeNode(ITreeNode)
      */
-    protected void setParent(ITreeNode parent) {
+    protected void setParent(ITaxonTreeNode parent) {
         if(parent instanceof Classification){
             this.parent = null;
             return;
@@ -318,13 +445,21 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      * @param parent
      */
     @Transient
-    protected void setParentTreeNode(ITreeNode parent){
+    protected void setParentTreeNode(ITaxonTreeNode parent, int index){
         // remove ourselves from the old parent
-        ITreeNode formerParent = this.getParentTreeNode();
+        ITaxonTreeNode formerParent = this.getParentTreeNode();
+        
+        //special case, child already exists for same parent
+        if (formerParent != null && formerParent.equals(parent)){
+        	int currentIndex = formerParent.getChildNodes().indexOf(this);
+        	if (currentIndex != -1 && currentIndex < index){
+        		index--;
+        	}	
+        }
+        //remove old parent
         if(formerParent instanceof TaxonNode){  //child was a child itself
             ((TaxonNode) formerParent).removeChildNode(this);
-        }
-        else if((formerParent instanceof Classification) && ! formerParent.equals(parent)){ //child was root in old tree
+        } else if((formerParent instanceof Classification) && ! formerParent.equals(parent)){ //child was root in old tree
             ((Classification) formerParent).removeChildNode(this);
         }
 
@@ -336,12 +471,18 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         setClassificationRecursively(classification);
 
         // add this node to the parent child nodes
-        parent.getChildNodes().add(this);
-
+        parent.getChildNodes().add(index, this);
+		//TODO workaround (see sortIndex doc)
+        //FIXME don't we need to update the parent's childNode index here??
+		for(int i = 0; i < childNodes.size(); i++){
+			childNodes.get(i).sortIndex = i;
+		}
+		this.sortIndex = index;
+        
         // update the children count
         if(parent instanceof TaxonNode){
             TaxonNode parentTaxonNode = (TaxonNode) parent;
-            parentTaxonNode.setCountChildren(parentTaxonNode.getCountChildren() + 1);
+            parentTaxonNode.setCountChildren(parent.getChildNodes().size());
         }
     }
 
@@ -357,7 +498,8 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         this.classification = classification;
     }
 
-    public Set<TaxonNode> getChildNodes() {
+    @Override
+    public List<TaxonNode> getChildNodes() {
         return childNodes;
     }
 
@@ -391,9 +533,9 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         for(TaxonNode childNode : getChildNodes()){
             childClone = (TaxonNode) childNode.clone();
             for (TaxonNode childChild:childNode.getChildNodes()){
-                childClone.addChildNode(childChild.cloneDescendants(), childChild.getReference(), childChild.getMicroReference(), childChild.getSynonymToBeUsed());
+                childClone.addChildNode(childChild.cloneDescendants(), childChild.getReference(), childChild.getMicroReference());
             }
-            clone.addChildNode(childClone, childNode.getReference(), childNode.getMicroReference(), childNode.getSynonymToBeUsed());
+            clone.addChildNode(childClone, childNode.getReference(), childNode.getMicroReference());
 
 
             //childClone.addChildNode(childNode.cloneDescendants());
@@ -408,22 +550,15 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      */
     protected Set<TaxonNode> getAncestors(){
         Set<TaxonNode> nodeSet = new HashSet<TaxonNode>();
-
-
         nodeSet.add(this);
-
         if(this.getParent() != null){
             nodeSet.addAll(((TaxonNode) this.getParent()).getAncestors());
         }
-
         return nodeSet;
     }
 
-    /**
-     * The reference for the parent child relationship
-     *
-     * @see eu.etaxonomy.cdm.model.taxon.ITreeNode#getReference()
-     */
+
+    @Override
     public Reference getReference() {
         return referenceForParentChildRelation;
     }
@@ -435,11 +570,8 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         this.referenceForParentChildRelation = reference;
     }
 
-    /**
-     *
-     *
-     * @see eu.etaxonomy.cdm.model.taxon.ITreeNode#getMicroReference()
-     */
+
+    @Override
     public String getMicroReference() {
         return microReferenceForParentChildRelation;
     }
@@ -464,12 +596,7 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
     protected void setCountChildren(int countChildren) {
         this.countChildren = countChildren;
     }
-//	public Taxon getOriginalConcept() {
-//		return originalConcept;
-//	}
-//	public void setOriginalConcept(Taxon originalConcept) {
-//		this.originalConcept = originalConcept;
-//	}
+
     public Synonym getSynonymToBeUsed() {
         return synonymToBeUsed;
     }
@@ -523,6 +650,7 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
      * @return true if the taxonNode has childNodes
      */
     @Transient
+    @Override
     public boolean hasChildNodes(){
         return childNodes.size() > 0;
     }
@@ -544,7 +672,7 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
         try{
         result = (TaxonNode)super.clone();
         result.getTaxon().addTaxonNode(result);
-        result.childNodes = new HashSet<TaxonNode>();
+        result.childNodes = new ArrayList<TaxonNode>();
         result.countChildren = 0;
 
         return result;
@@ -554,4 +682,7 @@ public class TaxonNode extends AnnotatableEntity implements ITreeNode, Cloneable
             return null;
         }
     }
+
+
+
 }
